Main Page Class Hierarchy Alphabetical List Compound List File List Compound Members File Members Related Pages

# ACE_Ordered_MultiSet_Iterator Class Template Reference

Implement a bidirectional iterator over an ordered multiset. This class template requires that < operator semantics be defined for the parameterized type <T>, but does not impose any restriction on how that ordering operator is implemented. More...

`#include <Containers_T.h>`

Collaboration diagram for ACE_Ordered_MultiSet_Iterator:

[legend]
List of all members.

## Public Methods
| ACE_Ordered_MultiSet_Iterator (ACE_Ordered_MultiSet<T> &s)
int | next (T *&next_item) const
| Pass back the <next_item> that hasn't been seen in the ordered multiset. Returns 0 when all items have been seen, else 1.
int | first (void)
| Repositions the iterator at the first item in the ordered multiset Returns 0 if the list is empty else 1.
int | last (void)
| Repositions the iterator at the last item in the ordered multiset Returns 0 if the list is empty else 1.
int | advance (void)
| Move forward by one element in the set. Returns 0 when all the items in the set have been seen, else 1.
int | retreat (void)
| Move backward by one element in the set. Returns 0 when all the items in the set have been seen, else 1.
int | done (void) const
| Returns 1 when all items have been seen, else 0.
void | dump (void) const
| Dump the state of an object.
T& | operator * (void)
| Returns a reference to the internal element <this> is pointing to.
## Public Attributes
| ACE_ALLOC_HOOK_DECLARE
| Declare the dynamic allocation hooks.
## Private Attributes
ACE_DNode<T>* | current_
| Pointer to the current node in the iteration.
ACE_Ordered_MultiSet<T>& | set_
| Pointer to the set we're iterating over.
## Friends
class | ACE_Ordered_MultiSet< T >

## Detailed Description

### template<class T> template class ACE_Ordered_MultiSet_Iterator

Implement a bidirectional iterator over an ordered multiset. This class template requires that < operator semantics be defined for the parameterized type <T>, but does not impose any restriction on how that ordering operator is implemented.

## Constructor & Destructor Documentation

template<classT>
ACE_Ordered_MultiSet_Iterator<T>::ACE_Ordered_MultiSet_Iterator<T> ( | ACE_Ordered_MultiSet< T >& s )

## Member Function Documentation

template<classT>
ACE_INLINE int ACE_Ordered_MultiSet_Iterator< T >::advance ( | void )

| Move forward by one element in the set. Returns 0 when all the items in the set have been seen, else 1.

template<classT>
ACE_INLINE int ACE_Ordered_MultiSet_Iterator< T >::done ( | void ) const

| Returns 1 when all items have been seen, else 0.

template<classT>
ACE_INLINE void ACE_Ordered_MultiSet_Iterator< T >::dump ( | void ) const

| Dump the state of an object.

template<classT>
ACE_INLINE int ACE_Ordered_MultiSet_Iterator< T >::first ( | void )

| Repositions the iterator at the first item in the ordered multiset Returns 0 if the list is empty else 1.

template<classT>
ACE_INLINE int ACE_Ordered_MultiSet_Iterator< T >::last ( | void )

| Repositions the iterator at the last item in the ordered multiset Returns 0 if the list is empty else 1.

template<classT>
int ACE_Ordered_MultiSet_Iterator<T>::next ( | T *& next_item ) const

| Pass back the <next_item> that hasn't been seen in the ordered multiset. Returns 0 when all items have been seen, else 1.

template<classT>
T & ACE_Ordered_MultiSet_Iterator<T>::operator * ( | void )

| Returns a reference to the internal element <this> is pointing to.

template<classT>
ACE_INLINE int ACE_Ordered_MultiSet_Iterator< T >::retreat ( | void )

| Move backward by one element in the set. Returns 0 when all the items in the set have been seen, else 1.

## Friends And Related Function Documentation

template<classT>
class ACE_Ordered_MultiSet`[friend]`

## Member Data Documentation

template<classT>
ACE_Ordered_MultiSet_Iterator<T>::ACE_ALLOC_HOOK_DECLARE

| Declare the dynamic allocation hooks.

template<classT>
ACE_DNode< T >* ACE_Ordered_MultiSet_Iterator<T>::current_`[private]`

| Pointer to the current node in the iteration.

template<classT>
ACE_Ordered_MultiSet< T >& ACE_Ordered_MultiSet_Iterator<T>::set_`[private]`

| Pointer to the set we're iterating over.

The documentation for this class was generated from the following files:

- Containers_T.h
- Containers_T.cpp
- Containers_T.i